--[[
   Copyright 2011 Kelly Riley (lunarwater)

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.

]]

import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Compendium.Common.Utils";
import "Compendium.Common.UI";
import "Compendium.Common.Resources.Bundle";
local rsrc = {};

AdvPaginationControl = class( Compendium.Common.UI.PaginationControl );
function AdvPaginationControl:Constructor( cursor )
    local fontColor=Turbine.UI.Color(1,.9,.5);
    local fontFace=Turbine.UI.Lotro.Font.Verdana14;
   	local page = Turbine.UI.Lotro.TextBox();
   	
	page:SetSize(35,16);
	page:SetVisible(true);
    page:SetBackColor(Turbine.UI.Color(.25,.35,.55));
    page:SetMultiline(false);
    page:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
    page:SetFont(Turbine.UI.Lotro.Font.TrajanPro13);
    page:SetForeColor(fontColor);
    page:SetOutlineColor(Turbine.UI.Color(0,0,0));
    --page:SetFontStyle(Turbine.UI.FontStyle.Outline);    
    page:SetWantsUpdates(false);
    page.FocusGained=function()
	   page:SetWantsUpdates(true);
	end
	page.FocusLost=function()
		page:SetWantsUpdates(false);
	end
   	page.Update = function(s,a) 
   		if page.Text ~= page:GetText() then
	   		page.Text = page:GetText();
	   		if self.cursor ~= nil then
	   			local success,pageNum = pcall(tonumber,page:GetText());
	   			if success and pageNum ~= nil then
	   				pageNum = self.cursor:SetPage(pageNum);
					if self.PageChanged ~= nil then
						self.PageChanged(self, 'page', self.cursor:CurPage());
					end 
	   				self:UpdatePagination();
	   			end
	   		end
	   	end
   	end
   	self.page = page;

    Compendium.Common.UI.PaginationControl.Constructor( self, cursor );

	page:SetParent(self);
   	page:SetPosition(self.prevBtn:GetLeft(),2);
   	self:UpdatePagination();
   	
end

function AdvPaginationControl:UpdatePagination()
	self.prevBtn:SetVisible(false);
	self.nextBtn:SetVisible(false);
	self:SetText('');
	if self.cursor ~= nil then
		self.page:SetVisible(true);
		local pageNum = self.cursor:CurPageNum();
		if pageNum ~= self.page:GetText() then self.page:SetText(pageNum) end;
		self:SetText(self.cursor:tostring() .. ' ' .. self.paginationText);
		if self.cursor:HasPrev() then self.prevBtn:SetVisible(true) end;
		if self.cursor:HasNext() then self.nextBtn:SetVisible(true) end;
		if self.prevBtn:IsVisible() then
			self.page:SetLeft(self.prevBtn:GetLeft() + self.prevBtn:GetWidth());
		else
			self.page:SetLeft(self.prevBtn:GetLeft());
		end
	else
		self.page:SetVisible(false);
	end
end
